



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>IOC 和DI（转载）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">IOC 和DI（转载）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 23:17:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><strong>IOC 是什么？</strong></h3>
<p>Ioc&mdash;Inversion of Control，即&ldquo;控制反转&rdquo;，不是什么技术，而是一种设计思想。在Java开发中，Ioc意味着将你设计好的对象交给容器控制，而不是传统的在你的对象内部直接控制。如何理解好Ioc呢？理解好Ioc的关键是要明确&ldquo;谁控制谁，控制什么，为何是反转（有反转就应该有正转了），哪些方面反转了&rdquo;，那我们来深入分析一下：</p>
<p>●<strong>谁控制谁，控制什么：</strong>传统Java SE程序设计，我们直接在对象内部通过new进行创建对象，是程序主动去创建依赖对象；而IoC是有专门一个容器来创建这些对象，即由Ioc容器来控制对象的创建；谁控制谁？当然是IoC 容器控制了对象；控制什么？那就是主要控制了外部资源获取（不只是对象包括比如文件等）。</p>
<p>●<strong>为何是反转，哪些方面反转了：</strong>有反转就有正转，传统应用程序是由我们自己在对象中主动控制去直接获取依赖对象，也就是正转；而反转则是由容器来帮忙创建及注入依赖对象；为何是反转？因为由容器帮我们查找及注入依赖对象，对象只是被动的接受依赖对象，所以是反转；哪些方面反转了？依赖对象的获取被反转了。</p>
<p>用图例说明一下，传统程序设计如图2-1，都是主动去创建相关对象然后再组合起来：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/786283/201705/786283-20170505152010101-745380739.jpg" /></p>
<p>图2-1 传统应用程序示意图</p>
<p>当有了IoC/DI的容器后，在客户端类中不再主动去创建这些对象了，如图2-2所示:</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/786283/201705/786283-20170505152029836-221841058.jpg" /></p>
<p>图2-2有IoC/DI容器后程序结构示意图</p>
<p><strong>IOC 能做什么？</strong></p>
<p>IoC不是一种技术，只是一种思想，一个重要的面向对象编程的法则，它能指导我们如何设计出松耦合、更优良的程序。传统应用程序都是由我们在类内部主动创建依赖对象，从而导致类与类之间高耦合，难于测试；有了IoC容器后，把创建和查找依赖对象的控制权交给了容器，由容器进行注入组合对象，所以对象与对象之间是松散耦合，这样也方便测试，利于功能复用，更重要的是使得程序的整个体系结构变得非常灵活。</p>
<p>其实IoC对编程带来的最大改变不是从代码上，而是从思想上，发生了&ldquo;主从换位&rdquo;的变化。应用程序原本是老大，要获取什么资源都是主动出击，但是在IoC/DI思想中，应用程序就变成被动的了，被动的等待IoC容器来创建并注入它所需要的资源了。</p>
<p>IoC很好的体现了面向对象设计法则之一&mdash;&mdash; 好莱坞法则：&ldquo;别找我们，我们找你&rdquo;；即由IoC容器帮对象找相应的依赖对象并注入，而不是由对象主动去找。</p>
<h3><strong>IOC 和DI：</strong></h3>
<p>DI&mdash;Dependency Injection，即&ldquo;依赖注入&rdquo;：是组件之间依赖关系由容器在运行期决定，形象的说，即由容器动态的将某个依赖关系注入到组件之中。依赖注入的目的并非为软件系统带来更多功能，而是为了提升组件重用的频率，并为系统搭建一个灵活、可扩展的平台。通过依赖注入机制，我们只需要通过简单的配置，而无需任何代码就可指定目标需要的资源，完成自身的业务逻辑，而不需要关心具体的资源来自何处，由谁实现。</p>
<p>理解DI的关键是：&ldquo;谁依赖谁，为什么需要依赖，谁注入谁，注入了什么&rdquo;，那我们来深入分析一下：</p>
<p>●<strong>谁依赖于谁：</strong>当然是应用程序依赖于IoC容器；</p>
<p>●<strong>为什么需要依赖：</strong>应用程序需要IoC容器来提供对象需要的外部资源；</p>
<p>●<strong>谁注入谁：</strong>很明显是IoC容器注入应用程序某个对象，应用程序依赖的对象；</p>
<p><strong>●注入了什么：</strong>就是注入某个对象所需要的外部资源（包括对象、资源、常量数据）。</p>
<p>IoC和DI由什么关系呢？其实它们是同一个概念的不同角度描述，由于控制反转概念比较含糊（可能只是理解为容器控制对象这一个层面，很难让人想到谁来维护对象关系），所以2004年大师级人物Martin Fowler又给出了一个新的名字：&ldquo;依赖注入&rdquo;，相对IoC 而言，<strong>&ldquo;</strong><strong>依赖注入&rdquo;</strong><strong>明确描述了&ldquo;被注入对象依赖IoC</strong><strong>容器配置依赖对象&rdquo;。</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1wj29g.html">Thinking in Unity3D：基于物理着色（PBS）的材质系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rgodr8.html">删除MSSQL中所有表的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq44wz5q.html">【转】如何使用VS 2013发布一个可以在Windows XP中独立运行的可执行文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pekl48.html">提示reg不是批处理命令怎么办</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4o42e8.html">自定义属性，资源文件attrs&period;xml</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8evzmx9.html">sql&colon; 查找约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj5vxd9.html">Linux堆内存管理深入分析--阿里聚安全</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o1nr49.html">【Android布局】在程序中设置android&colon;gravity 和 android&colon;layout&lowbar;Gravity属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geed608.html">not accessible due to restriction on required library</a>
		</li>
						<li><a href="https://www.batexi.com/a/950mxm68.html">json python api</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m17em8.html">ASP&period;NET MVC5&plus;EF6&plus;EasyUI 后台管理系统（88）-Excel导入和导出-主从表结构导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyk3we9.html">Throughtput收集器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwrr39.html">结合别人的文章，做RocketMQ的一点原理分析，结合源码&lpar;尽量&rpar;----未完待续</a>
		</li>
						<li><a href="https://www.batexi.com/a/960wkmv9.html">centos系统swap设置 查看swap分区的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdvkrj9.html">HP Instant Information</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p3vm0q.html">Linux第一二章笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/902lmeoq.html">Java学习（异常类练习题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnl64rq.html">2016-2017 CT S03E07&colon; Codeforces Trainings Season 3 Episode 7</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4px4g3q.html">Codeforces Round &num;304 &lpar;Div&period; 2&rpar; B&period; Soldier and Badges 水题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77x2p1q.html">20145240《网络对抗》MSF基础应用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kjkdr59.html">&dollar;inject</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e43xze9.html">【转】matlab学习&lpar;5&rpar; 读取excel文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllw7m6q.html">python中sys和os模块的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy6ndmq.html">Linq分组查询统计</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ryok48.html">ios-上传图片到后台</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r45y49.html">Centos7&period;4安装配置haproxy和Keepalived补充内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r562gdq.html">ajax请求完成执行的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllw461q.html">mysql识别中文</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwgn6j9.html">ADB文件及文件夹操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w354nq.html">JavaWeb&mdash;&mdash;jsp-config</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
